<!--
  This page allows to easily print the history details in a valid design.
  It improves cross-browser compatibility that is not easily reachable with print media queries.
-->

<template>
  <div>
    <AtomAlert
      v-if="printInformations?.error"
      :alert-type="AlertType.Error"
      message="Les informations du bénéficiaire n'ont pas pu être chargées."
    />
    <AtomLoader
      v-else-if="printInformations?.pending"
      class="fr-mx-auto"
    />
    <template
      v-else-if="
        printInformations?.helpRequest && printInformations?.fileInstructionType
      "
    >
      <PrintHelpRequest
        :help-request="printInformations.helpRequest"
        :file-instruction-type="printInformations.fileInstructionType"
        @on-updated="onUpdated"
      />
    </template>

    <template v-else-if="printInformations?.housingHelpRequest">
      <PrintHousingHelpRequest
        :housing-help-request="printInformations.housingHelpRequest"
        @on-updated="onUpdated"
      />
    </template>

    <template v-else-if="printInformations?.followup">
      <PrintFollowup
        :followup="printInformations.followup"
        @on-updated="onUpdated"
      />
    </template>
  </div>
</template>

<script setup lang="ts">
  import { FileInstructionType } from '@prisma/client'
  import { AlertType } from '~/utils/constants/alert'
  import { TypeSuivi } from '~/client/options'
  import {
    HousingHelpRequestOutput,
    HelpRequestOutput,
    FollowupOutput
  } from '~/components/PrintHelpRequest/types'
  import { BeneficiaryTab } from '~/utils/constants/beneficiary'
  import { routes } from '~/utils/routes'
  import { BeneficiaryHistoryAction, EventCategory } from '~/types/matomo'

  const route = useRoute()

  const trpcClient = useTrpcClient()
  const helpRequestId = route.params.id as string

  definePageMeta({
    layout: false
  })
  // Define page title
  useHead({
    title: routes.file.AppHistoryPrint.title
  })

  const historyType = route.query.type

  type PrintInformations =
    | {
        pending?: any
        error?: any
        helpRequest?: HelpRequestOutput
        housingHelpRequest?: HousingHelpRequestOutput
        followup?: FollowupOutput
        fileInstructionType?: FileInstructionType
      }
    | undefined

  const trackWithMatomo = (historyType: string | undefined) => {
    const getHistoryAction = (historyType: string | undefined) => {
      switch (historyType) {
        case 'Financial':
          return BeneficiaryHistoryAction.PrintFinancialHelpRequest
        case 'Housing':
          return BeneficiaryHistoryAction.PrintHousingHelpRequest
        case 'Other':
          return BeneficiaryHistoryAction.PrintOtherHelpRequest
        case 'Followup':
          return BeneficiaryHistoryAction.PrintFollowup
        case TypeSuivi.AllHelpRequest:
          return BeneficiaryHistoryAction.PrintAllHelpRequest
        default:
          return BeneficiaryHistoryAction.Print
      }
    }
    useMatomo().trackEvent(EventCategory.History, getHistoryAction(historyType))
  }

  const getPrintInformations = async (): Promise<PrintInformations> => {
    // Get helpRequest data
    if (historyType === TypeSuivi.AllHelpRequest) {
      const { data, pending, error } =
        await trpcClient.helpRequest.getOne.useQuery({
          id: helpRequestId
        })
      trackWithMatomo(data.value?.helpRequest.fileInstruction.type)
      return {
        pending: pending.value ? pending : undefined,
        error: error.value ? error : undefined,
        helpRequest: data.value?.helpRequest,
        fileInstructionType: data.value?.helpRequest.fileInstruction.type // 'Other' | 'Financial'
      }
    }

    if (historyType === TypeSuivi.HousingHelpRequest) {
      const { data, pending, error } =
        await trpcClient.housingHelpRequest.getOne.useQuery({
          id: helpRequestId
        })
      trackWithMatomo(data.value?.housingHelpRequest.fileInstruction.type)
      return {
        pending: pending.value ? pending : undefined,
        error: error.value ? error : undefined,
        housingHelpRequest: data.value?.housingHelpRequest,
        fileInstructionType: data.value?.housingHelpRequest.fileInstruction.type // 'Housing'
      }
    }

    if (historyType === TypeSuivi.Followup) {
      const { data, pending, error } =
        await trpcClient.followup.getOne.useQuery({ id: helpRequestId })
      trackWithMatomo(data.value?.followup.socialSupportType)
      return {
        pending: pending.value ? pending : undefined,
        error: error.value ? error : undefined,
        followup: data.value?.followup
      }
    }
  }

  const printInformations = await getPrintInformations()

  const getBeneficiaryDetails = async (id: string | undefined) => {
    if (!id) {
      return null
    }
    const { beneficiary } = await useBeneficiaryDetails(id)
    return beneficiary
  }

  const getBeneficiaryId = () => {
    if (historyType === TypeSuivi.Followup) {
      return printInformations?.followup?.beneficiaryId
    }
    if (historyType === TypeSuivi.AllHelpRequest) {
      return printInformations?.helpRequest?.fileInstruction.socialSupport
        .beneficiaryId
    }
    if (historyType === TypeSuivi.HousingHelpRequest) {
      return printInformations?.housingHelpRequest?.fileInstruction
        .socialSupport.beneficiaryId
    }
  }

  const getFfamilyFileId = async () => {
    const beneficiary = await getBeneficiaryDetails(getBeneficiaryId())
    if (historyType === TypeSuivi.Followup) {
      return printInformations?.followup?.familyFileId
    }
    if (
      historyType === TypeSuivi.AllHelpRequest ||
      historyType === TypeSuivi.HousingHelpRequest
    ) {
      return beneficiary?.value?.familyFileId
    }
  }
  const getItemId = () => {
    if (historyType === TypeSuivi.Followup) {
      return printInformations?.followup?.socialSupportId
    }
    if (historyType === TypeSuivi.AllHelpRequest) {
      return printInformations?.helpRequest?.fileInstruction.socialSupport.id
    }
    if (historyType === TypeSuivi.HousingHelpRequest) {
      return printInformations?.housingHelpRequest?.fileInstruction
        .socialSupport.id
    }
  }

  const onUpdated = () => {
    window.print()
    window.addEventListener('afterprint', onAfterPrint)
  }

  onMounted(() => {
    window.addEventListener('afterprint', onAfterPrint)
  })
  onUnmounted(() => {
    window.removeEventListener('afterprint', onAfterPrint)
  })
  async function onAfterPrint() {
    const familyFileId = await getFfamilyFileId()
    navigateTo(
      routes.file.AppFile.path(familyFileId, {
        beneficiaryId: getBeneficiaryId(),
        item: getItemId(),
        tab: BeneficiaryTab.History
      })
    )
  }
</script>

<style lang="scss" scoped>
  @media print {
    :deep(.fr-icon-success-line::before) {
      content: '✅';
    }

    :deep(.fr-icon-close-circle-line::before) {
      content: '❌';
    }

    :deep(.fr-container) {
      max-width: none;
      padding: 0;
    }
  }
</style>
